// This code is an adaptation of "Geeks for Geeks" code by Ankur. The Henri Cohen Algorithm 10.3.4 (Parallel Inverse Modulo N)
// Requires one of Euclids extended algorithms to compute Uck + vN = d and d = (ck , N)
//Where ck are affine coordinates on the Weierstrass Eq. (suggested Montgomery Group) See This web page button, Appendix 1 for some theory
// So whilst "Recursive" does demonstrate obtaining u,v for the inputs ck and N
// Depth of recursion could be initially problematic, so check for iteritive button. warren

#include <iostream>
#include <cmath>
using namespace std;
int gcd(int a, int b) {
	if (b == 0) {
		return a;
	}
	else {
		return gcd(b, a % b);
	}
}
int Extended_Euclidean_2(int a, int b, int* u, int* v)
{
	int u1 = 0;
	int v1 = 0;
	if (a == 0) {
		*u = 0;
		*v = 1;
		return b;
	}
	int gcd = Extended_Euclidean_2((b % a), a, &u1, &v1);
	*u = v1 - (b / a) * u1;
	*v = u1;
	return gcd;
}

int main()
{
	int u; int v;  
	int a; int b;
	int gt;
	cout << "Enter number a " << endl;
	cin >> a;
	cout << " Enter number b " << endl;
	cin >> b;
	gt = Extended_Euclidean_2(a, b, &u, &v);
	cout << "GCD = " << gt << endl;
}